Attribute VB_Name = "mdlFont"

Option Explicit

Private Type SHITEMID
    cb As Long
    abID As Byte
End Type
Private Type ITEMIDLIST
    mkid As SHITEMID
End Type

Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function AddFontResource Lib "gdi32" Alias "AddFontResourceA" (ByVal lpFileName As String) As Long
Private Declare Function RemoveFontResource Lib "gdi32" Alias "RemoveFontResourceA" (ByVal lpFileName As String) As Long

Private Function GetSpecialfolder(CSIDL As Long) As String
    Dim R As Long
    Dim path As String
    Dim IDL As ITEMIDLIST
    R = SHGetSpecialFolderLocation(100, CSIDL, IDL)
    If R = 0 Then
        path = Space$(512)
        R = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal path$)
        GetSpecialfolder = Left$(path, InStr(path, Chr$(0)) - 1)
        Exit Function
    End If
    GetSpecialfolder = ""
End Function

Public Sub AddFonts()
    Dim f() As Byte
    Dim hFile As Long, Result As Long
    Dim Counter As Byte
    Dim SysFolder As String
    SysFolder = GetSpecialfolder(37) & IIf(Right(GetSpecialfolder(37), 1) <> "\", "\", "")
    For Counter = LBound(UsedFonts) To UBound(UsedFonts)
        f = LoadResData(UsedFonts(Counter), "Font")
        Open SysFolder & UsedFonts(Counter) & ".ttf" For Binary As 1
        Put 1, , f
        Close 1
        AddFontResource UsedFonts(Counter) & ".ttf "
    Next
End Sub

Public Sub RemoveFonts()
    Dim Counter As Byte
    Dim SysFolder As String
    SysFolder = GetSpecialfolder(37) & IIf(Right(GetSpecialfolder(37), 1) <> "\", "\", "")
    For Counter = LBound(UsedFonts) To UBound(UsedFonts)
        RemoveFontResource (SysFolder & UsedFonts(Counter) & ".ttf")
    Next
End Sub
